Imports System.Runtime.InteropServices
Imports AddinExpress.OL
Imports Outlook = Microsoft.Office.Interop.Outlook
Imports System.Windows.Forms

Public Class ADXOlForm2

    Public Sub New()
        MyBase.New()

        InitializeComponent()

    End Sub

    Private Function GetCurrentMail() As Outlook.MailItem
        If Me.InspectorObj IsNot Nothing Then
            Dim inspector As Outlook.Inspector = TryCast(Me.InspectorObj, Outlook.Inspector)
            If inspector IsNot Nothing Then
                Dim currentItem As Object = inspector.CurrentItem
                Dim mail As Outlook.MailItem = TryCast(currentItem, Outlook.MailItem)
                If mail IsNot Nothing Then
                    Return mail
                Else
                    If currentItem IsNot Nothing Then
                        Marshal.ReleaseComObject(currentItem)
                        currentItem = Nothing
                    End If
                    Return Nothing
                End If
            End If
        End If
        Return Nothing
    End Function

    Private Sub button1_Click(sender As System.Object, e As System.EventArgs) Handles button1.Click
        Dim mail As Outlook.MailItem = GetCurrentMail()
        If mail IsNot Nothing Then
            Try
                If (TryCast(Me.AddinModule, adx_ol_vb_formVisibility.AddinModule).HostMajorVersion < 11) Then
                    MessageBox.Show("In Outlook 2000 SP1 and Outlook XP, accessing some fields triggers the Outlook Security Guard", _
                   "Controlling the Form Visibility", MessageBoxButtons.OK, MessageBoxIcon.None)
                End If
                If listBox1.SelectedItem IsNot Nothing Then
                    mail.[To] = listBox1.SelectedItem.ToString()
                End If
            Finally
                Marshal.ReleaseComObject(mail)
            End Try
        End If
    End Sub

    Private Sub button2_Click(sender As System.Object, e As System.EventArgs) Handles button2.Click
        Dim mail As Outlook.MailItem = GetCurrentMail()
        If mail IsNot Nothing Then
            Try
                If listBox2.SelectedItem IsNot Nothing Then
                    mail.Subject = listBox2.SelectedItem.ToString()
                End If
            Finally
                Marshal.ReleaseComObject(mail)
            End Try
        End If
    End Sub

    Private Sub button3_Click(sender As System.Object, e As System.EventArgs) Handles button3.Click
        If (TryCast(Me.AddinModule, adx_ol_vb_formVisibility.AddinModule).HostMajorVersion >= 12) Then
            ' button in MailCompose ribbon
            TryCast(Me.AddinModule, adx_ol_vb_formVisibility.AddinModule).adxRibbonButton1.Enabled = True
            ' button in MailRead ribbon
            TryCast(Me.AddinModule, adx_ol_vb_formVisibility.AddinModule).adxRibbonButton2.Enabled = True
        Else
            TryCast(Me.AddinModule, adx_ol_vb_formVisibility.AddinModule).adxInspectorCommandBarButton1.Enabled = True
        End If
        Me.Hide()
    End Sub
End Class
