﻿Imports System.Runtime.InteropServices
Imports System.ComponentModel
Imports System.Windows.Forms
Imports AddinExpress.MSO
Imports Outlook = Microsoft.Office.Interop.Outlook
Imports System.Globalization

'Add-in Express Add-in Module
<GuidAttribute("F9AF3F1D-7E4A-4BFA-AC3D-015F9E8933E6"), ProgIdAttribute("adx_ol_vb_formVisibility.AddinModule")> _
Public Class AddinModule
    Inherits AddinExpress.MSO.ADXAddinModule
    Friend WithEvents adxInspectorCommandBarButton1 As AddinExpress.MSO.ADXCommandBarButton
    Private WithEvents imageList1 As System.Windows.Forms.ImageList
    Private WithEvents adxRibbonTab1 As AddinExpress.MSO.ADXRibbonTab
    Private WithEvents adxRibbonGroup1 As AddinExpress.MSO.ADXRibbonGroup
    Friend WithEvents adxRibbonButton1 As AddinExpress.MSO.ADXRibbonButton
    Private WithEvents adxRibbonTab2 As AddinExpress.MSO.ADXRibbonTab
    Private WithEvents adxRibbonGroup2 As AddinExpress.MSO.ADXRibbonGroup
    Friend WithEvents adxRibbonButton2 As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents AdxOlFormsManager1 As AddinExpress.OL.ADXOlFormsManager
    Friend WithEvents AdxOlFormsCollectionItem1 As AddinExpress.OL.ADXOlFormsCollectionItem
    Friend WithEvents AdxOlFormsCollectionItem2 As AddinExpress.OL.ADXOlFormsCollectionItem
    Private WithEvents adxOlInspectorCommandBar1 As AddinExpress.MSO.ADXOlInspectorCommandBar
    Private WithEvents RestoreCommandBarButton As AddinExpress.MSO.ADXCommandBarButton
    Private WithEvents adxExplorerCommandBarComboBox As AddinExpress.MSO.ADXCommandBarComboBox
    Private WithEvents adxOlExplorerCommandBar1 As AddinExpress.MSO.ADXOlExplorerCommandBar
    Private Const WM_INSPECTOR_BUTTON_CLICK As Integer = 1024 + 1000
    Public ShowByInspectorCommandBarButtonClick As Boolean = False
    Private explorerMode As ExplorerFormDisplayMode = ExplorerFormDisplayMode.Unknown
    Private _inboxFolder As Outlook.MAPIFolder = Nothing
    Private _rootFolder As Outlook.MAPIFolder = Nothing
    Private _hiddenExplorerForm As ADXOlForm1 = Nothing
    Friend WithEvents AdxRibbonTab3 As AddinExpress.MSO.ADXRibbonTab
    Friend WithEvents AdxRibbonGroup3 As AddinExpress.MSO.ADXRibbonGroup
    Friend WithEvents AdxRibbonComboBox1 As AddinExpress.MSO.ADXRibbonComboBox
    Friend WithEvents AdxRibbonButton3 As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents AdxRibbonItem1 As AddinExpress.MSO.ADXRibbonItem
    Friend WithEvents AdxRibbonItem2 As AddinExpress.MSO.ADXRibbonItem

    Private Enum ExplorerFormDisplayMode
        Unknown
        InboxOnlyItem
        InboxAndSubfoldersItem
    End Enum

#Region " Component Designer generated code. "
    'Required by designer
    Private components As System.ComponentModel.IContainer

    'Required by designer - do not modify
    'the following method
    Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container()
        Dim resources As System.ComponentModel.ComponentResourceManager = New System.ComponentModel.ComponentResourceManager(GetType(AddinModule))
        Me.adxOlExplorerCommandBar1 = New AddinExpress.MSO.ADXOlExplorerCommandBar(Me.components)
        Me.adxExplorerCommandBarComboBox = New AddinExpress.MSO.ADXCommandBarComboBox(Me.components)
        Me.RestoreCommandBarButton = New AddinExpress.MSO.ADXCommandBarButton(Me.components)
        Me.adxOlInspectorCommandBar1 = New AddinExpress.MSO.ADXOlInspectorCommandBar(Me.components)
        Me.adxInspectorCommandBarButton1 = New AddinExpress.MSO.ADXCommandBarButton(Me.components)
        Me.imageList1 = New System.Windows.Forms.ImageList(Me.components)
        Me.adxRibbonTab1 = New AddinExpress.MSO.ADXRibbonTab(Me.components)
        Me.adxRibbonGroup1 = New AddinExpress.MSO.ADXRibbonGroup(Me.components)
        Me.adxRibbonButton1 = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.adxRibbonTab2 = New AddinExpress.MSO.ADXRibbonTab(Me.components)
        Me.adxRibbonGroup2 = New AddinExpress.MSO.ADXRibbonGroup(Me.components)
        Me.adxRibbonButton2 = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.AdxOlFormsManager1 = New AddinExpress.OL.ADXOlFormsManager(Me.components)
        Me.AdxOlFormsCollectionItem1 = New AddinExpress.OL.ADXOlFormsCollectionItem(Me.components)
        Me.AdxOlFormsCollectionItem2 = New AddinExpress.OL.ADXOlFormsCollectionItem(Me.components)
        Me.AdxRibbonTab3 = New AddinExpress.MSO.ADXRibbonTab(Me.components)
        Me.AdxRibbonGroup3 = New AddinExpress.MSO.ADXRibbonGroup(Me.components)
        Me.AdxRibbonComboBox1 = New AddinExpress.MSO.ADXRibbonComboBox(Me.components)
        Me.AdxRibbonButton3 = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.AdxRibbonItem1 = New AddinExpress.MSO.ADXRibbonItem(Me.components)
        Me.AdxRibbonItem2 = New AddinExpress.MSO.ADXRibbonItem(Me.components)
        '
        'adxOlExplorerCommandBar1
        '
        Me.adxOlExplorerCommandBar1.CommandBarName = "VisibilityVs2005vb1"
        Me.adxOlExplorerCommandBar1.CommandBarTag = "24ae82fc-85df-4f2f-adfc-9a4c8af3c32a"
        Me.adxOlExplorerCommandBar1.Controls.Add(Me.adxExplorerCommandBarComboBox)
        Me.adxOlExplorerCommandBar1.Controls.Add(Me.RestoreCommandBarButton)
        Me.adxOlExplorerCommandBar1.Temporary = True
        Me.adxOlExplorerCommandBar1.UpdateCounter = 40
        '
        'adxExplorerCommandBarComboBox
        '
        Me.adxExplorerCommandBarComboBox.Caption = "Show ADXOlForm1 for"
        Me.adxExplorerCommandBarComboBox.ControlTag = "1a290227-2788-431a-9313-3dde4dccb5ee"
        Me.adxExplorerCommandBarComboBox.DropDownWidth = 200
        Me.adxExplorerCommandBarComboBox.Items.AddRange(New String() {"Inbox only", "Inbox and subfolders"})
        Me.adxExplorerCommandBarComboBox.ListIndex = 1
        Me.adxExplorerCommandBarComboBox.Style = AddinExpress.MSO.ADXMsoComboStyle.adxMsoComboLabel
        Me.adxExplorerCommandBarComboBox.Temporary = True
        Me.adxExplorerCommandBarComboBox.UpdateCounter = 78
        Me.adxExplorerCommandBarComboBox.Width = 250
        '
        'RestoreCommandBarButton
        '
        Me.RestoreCommandBarButton.Caption = "Restore ADXOlForm1"
        Me.RestoreCommandBarButton.ControlTag = "bef20a3a-d68e-4209-ab2b-1baf34b5f927"
        Me.RestoreCommandBarButton.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.RestoreCommandBarButton.Temporary = True
        Me.RestoreCommandBarButton.UpdateCounter = 33
        Me.RestoreCommandBarButton.Visible = False
        '
        'adxOlInspectorCommandBar1
        '
        Me.adxOlInspectorCommandBar1.CommandBarName = "VisibilityVs2005vb1"
        Me.adxOlInspectorCommandBar1.CommandBarTag = "67581785-5a9c-44a5-bc30-7e79c5df59b6"
        Me.adxOlInspectorCommandBar1.Controls.Add(Me.adxInspectorCommandBarButton1)
        Me.adxOlInspectorCommandBar1.Temporary = True
        Me.adxOlInspectorCommandBar1.UpdateCounter = 48
        '
        'adxInspectorCommandBarButton1
        '
        Me.adxInspectorCommandBarButton1.Caption = "Show ADXOlForm2"
        Me.adxInspectorCommandBarButton1.ControlTag = "49e7fea3-b8bf-4e41-94c4-bbe97252e3ef"
        Me.adxInspectorCommandBarButton1.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.adxInspectorCommandBarButton1.Temporary = True
        Me.adxInspectorCommandBarButton1.UpdateCounter = 33
        '
        'imageList1
        '
        Me.imageList1.ImageStream = CType(resources.GetObject("imageList1.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.imageList1.TransparentColor = System.Drawing.Color.Transparent
        Me.imageList1.Images.SetKeyName(0, "adx")
        '
        'adxRibbonTab1
        '
        Me.adxRibbonTab1.Caption = "Add-in Express"
        Me.adxRibbonTab1.Controls.Add(Me.adxRibbonGroup1)
        Me.adxRibbonTab1.Id = "FormEmbeddingSamplesID"
        Me.adxRibbonTab1.InsertBeforeId = "TabNewMailMessage"
        Me.adxRibbonTab1.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookMailCompose
        Me.adxRibbonTab1.Shared = True
        '
        'adxRibbonGroup1
        '
        Me.adxRibbonGroup1.Caption = "Form Region Visibility"
        Me.adxRibbonGroup1.Controls.Add(Me.adxRibbonButton1)
        Me.adxRibbonGroup1.Id = "adxRibbonGroup_73cfcd68ce6a4926bb8e4ba8e7e2b1b5"
        Me.adxRibbonGroup1.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.adxRibbonGroup1.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookMailCompose
        '
        'adxRibbonButton1
        '
        Me.adxRibbonButton1.Caption = "Show ADXOlForm2"
        Me.adxRibbonButton1.Id = "adxRibbonButton_3fb17369b68a4a21b25b52b95f6e5b75"
        Me.adxRibbonButton1.Image = 0
        Me.adxRibbonButton1.ImageList = Me.imageList1
        Me.adxRibbonButton1.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.adxRibbonButton1.Pressed = True
        Me.adxRibbonButton1.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookMailCompose
        '
        'adxRibbonTab2
        '
        Me.adxRibbonTab2.Caption = "Add-in Express"
        Me.adxRibbonTab2.Controls.Add(Me.adxRibbonGroup2)
        Me.adxRibbonTab2.Id = "FormEmbeddingSamplesID"
        Me.adxRibbonTab2.InsertBeforeId = "TabReadMessage"
        Me.adxRibbonTab2.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookMailRead
        Me.adxRibbonTab2.Shared = True
        '
        'adxRibbonGroup2
        '
        Me.adxRibbonGroup2.Caption = "Form Region Visibility"
        Me.adxRibbonGroup2.Controls.Add(Me.adxRibbonButton2)
        Me.adxRibbonGroup2.Id = "adxRibbonGroup_9fdb52df5aa44585a28d06d0966dd10b"
        Me.adxRibbonGroup2.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.adxRibbonGroup2.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookMailRead
        '
        'adxRibbonButton2
        '
        Me.adxRibbonButton2.Caption = "Show ADXOlForm2"
        Me.adxRibbonButton2.Id = "adxRibbonButton_99eedf32af6c43e69c0981050dea17ab"
        Me.adxRibbonButton2.Image = 0
        Me.adxRibbonButton2.ImageList = Me.imageList1
        Me.adxRibbonButton2.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.adxRibbonButton2.Pressed = True
        Me.adxRibbonButton2.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookMailRead
        '
        'AdxOlFormsManager1
        '
        Me.AdxOlFormsManager1.Items.Add(Me.AdxOlFormsCollectionItem1)
        Me.AdxOlFormsManager1.Items.Add(Me.AdxOlFormsCollectionItem2)
        Me.AdxOlFormsManager1.SetOwner(Me)
        '
        'AdxOlFormsCollectionItem1
        '
        Me.AdxOlFormsCollectionItem1.ExplorerLayout = AddinExpress.OL.ADXOlExplorerLayout.BottomSubpane
        Me.AdxOlFormsCollectionItem1.FormClassName = "adx_ol_vb_formVisibility.ADXOlForm1"
        Me.AdxOlFormsCollectionItem1.UseOfficeThemeForBackground = True
        '
        'AdxOlFormsCollectionItem2
        '
        Me.AdxOlFormsCollectionItem2.FormClassName = "adx_ol_vb_formVisibility.ADXOlForm2"
        Me.AdxOlFormsCollectionItem2.InspectorItemTypes = AddinExpress.OL.ADXOlInspectorItemTypes.olMail
        Me.AdxOlFormsCollectionItem2.InspectorLayout = AddinExpress.OL.ADXOlInspectorLayout.RightSubpane
        Me.AdxOlFormsCollectionItem2.UseOfficeThemeForBackground = True
        '
        'AdxRibbonTab3
        '
        Me.AdxRibbonTab3.Caption = "Add-in Express"
        Me.AdxRibbonTab3.Controls.Add(Me.AdxRibbonGroup3)
        Me.AdxRibbonTab3.Id = "adxRibbonTab_283fddb1692d40e793e72ac8ee2bdf91"
        Me.AdxRibbonTab3.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer
        '
        'AdxRibbonGroup3
        '
        Me.AdxRibbonGroup3.Caption = "Form Region Visibility"
        Me.AdxRibbonGroup3.Controls.Add(Me.AdxRibbonComboBox1)
        Me.AdxRibbonGroup3.Controls.Add(Me.AdxRibbonButton3)
        Me.AdxRibbonGroup3.Id = "adxRibbonGroup_aa6bc27feeae463096b0fc35e89cc839"
        Me.AdxRibbonGroup3.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.AdxRibbonGroup3.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer
        '
        'AdxRibbonComboBox1
        '
        Me.AdxRibbonComboBox1.Caption = "Show ADXOlForm1 for"
        Me.AdxRibbonComboBox1.Id = "adxRibbonComboBox_3f2a35f1be584399afeef4c49758b09b"
        Me.AdxRibbonComboBox1.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.AdxRibbonComboBox1.Items.Add(Me.AdxRibbonItem1)
        Me.AdxRibbonComboBox1.Items.Add(Me.AdxRibbonItem2)
        Me.AdxRibbonComboBox1.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer
        '
        'AdxRibbonButton3
        '
        Me.AdxRibbonButton3.Caption = "Restore ADXOlForm1"
        Me.AdxRibbonButton3.Id = "adxRibbonButton_defe61ff4dee465dbca992e96dc71524"
        Me.AdxRibbonButton3.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.AdxRibbonButton3.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer
        '
        'AdxRibbonItem1
        '
        Me.AdxRibbonItem1.Caption = "Inbox only"
        Me.AdxRibbonItem1.Id = "adxRibbonItem_18b2adf4cd6b45829b2cc386b2f3f85c"
        Me.AdxRibbonItem1.ImageTransparentColor = System.Drawing.Color.Transparent
        '
        'AdxRibbonItem2
        '
        Me.AdxRibbonItem2.Caption = "Inbox and subfolders"
        Me.AdxRibbonItem2.Id = "adxRibbonItem_e3980317bf4946e892d49e785bdc110a"
        Me.AdxRibbonItem2.ImageTransparentColor = System.Drawing.Color.Transparent
        '
        'AddinModule
        '
        Me.AddinName = "adx_ol_vb_formVisibility"
        Me.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook

    End Sub

#End Region

#Region " Add-in Express automatic code "

    'Required by Add-in Express - do not modify
    'the methods within this region

    Public Overrides Function GetContainer() As System.ComponentModel.IContainer
        If components Is Nothing Then
            components = New System.ComponentModel.Container
        End If
        GetContainer = components
    End Function

    <ComRegisterFunctionAttribute()> _
    Public Shared Sub AddinRegister(ByVal t As Type)
        AddinExpress.MSO.ADXAddinModule.ADXRegister(t)
    End Sub

    <ComUnregisterFunctionAttribute()> _
    Public Shared Sub AddinUnregister(ByVal t As Type)
        AddinExpress.MSO.ADXAddinModule.ADXUnregister(t)
    End Sub

    Public Overrides Sub UninstallControls()
        MyBase.UninstallControls()
    End Sub

#End Region

    Public Property HiddenExplorerForm() As ADXOlForm1
        Get
            Return _hiddenExplorerForm
        End Get
        Set(ByVal value As ADXOlForm1)
            _hiddenExplorerForm = value
            If _hiddenExplorerForm Is Nothing Then
                RestoreCommandBarButton.Visible = False
            Else
                RestoreCommandBarButton.Visible = True
            End If
        End Set
    End Property

    Public Sub New()
        MyBase.New()

        Application.EnableVisualStyles()
        'This call is required by the Component Designer
        InitializeComponent()

        'Please add any initialization code to the AddinInitialize event handler

    End Sub

    Public Shared Shadows ReadOnly Property CurrentInstance() As AddinModule
        Get
            Return CType(AddinExpress.MSO.ADXAddinModule.CurrentInstance, AddinModule)
        End Get
    End Property

    Public ReadOnly Property OutlookApp() As Outlook._Application
        Get
            Return CType(HostApplication, Outlook._Application)
        End Get
    End Property

    Private Sub adxInspectorCommandBarButton1_Click(sender As System.Object) Handles adxInspectorCommandBarButton1.Click
        Me.SendMessage(WM_INSPECTOR_BUTTON_CLICK, IntPtr.Zero, IntPtr.Zero)
    End Sub

    Private Sub AddinModule_OnSendMessage(sender As System.Object, e As AddinExpress.MSO.ADXSendMessageEventArgs) Handles MyBase.OnSendMessage
        If e.Message = WM_INSPECTOR_BUTTON_CLICK Then
            ProcessInspectorButtonClick()
        End If
    End Sub

    Private Sub ProcessInspectorButtonClick()
        ShowByInspectorCommandBarButtonClick = True
        Try
            Dim activeInspector As Outlook.Inspector = OutlookApp.ActiveInspector()
            If activeInspector IsNot Nothing Then
                Try
                    AdxOlFormsCollectionItem2.ApplyTo(activeInspector)
                Finally
                    Marshal.ReleaseComObject(activeInspector)
                End Try
            End If
        Finally
            ShowByInspectorCommandBarButtonClick = False
        End Try
    End Sub

    Private Sub SetExplorerFormDisplayMode(ByVal ExplorerMode As ExplorerFormDisplayMode, ByVal currentFolder As Outlook.MAPIFolder)
        If Me.explorerMode <> ExplorerMode Then
            Select Case ExplorerMode
                Case ExplorerFormDisplayMode.InboxOnlyItem
                    'Hide a visible form when the current folder is not the Inbox folder.
                    Dim TheCurrentFolderIsInboxFolder As Boolean = IsInboxFolder(currentFolder)
                    If Not TheCurrentFolderIsInboxFolder Then
                        Dim visibleForm As AddinExpress.OL.ADXOlForm = Nothing
                        For i As Integer = 0 To AdxOlFormsCollectionItem1.FormInstanceCount - 1
                            If AdxOlFormsCollectionItem1.FormInstances(i).Visible Then
                                visibleForm = AdxOlFormsCollectionItem1.FormInstances(i)
                                Exit For
                            End If
                        Next
                        If visibleForm IsNot Nothing Then
                            visibleForm.Hide()
                        End If
                    End If
                    'Note that all invisible cached forms will be deleted.
                    AdxOlFormsCollectionItem1.FolderName = InboxFullFolderName()
                Case ExplorerFormDisplayMode.InboxAndSubfoldersItem
                    'See the ADXOlFormsManager.ADXBeforeFormInstanceCreate event for the code that works in the InboxAndSubfoldersItem mode.
                    'Note that all invisible cached forms will be deleted.
                    AdxOlFormsCollectionItem1.FolderName = "*"
            End Select

            Me.explorerMode = ExplorerMode
        End If
    End Sub

    Private Sub adxExplorerCommandBarComboBox_Change(sender As System.Object) Handles adxExplorerCommandBarComboBox.Change
        Dim activeExplorer As Outlook.Explorer = Nothing
        Dim currentFolder As Outlook.MAPIFolder = Nothing
        Try
            activeExplorer = OutlookApp.ActiveExplorer()
            If activeExplorer IsNot Nothing Then
                currentFolder = activeExplorer.CurrentFolder
            End If
            Dim newExplorerMode As ExplorerFormDisplayMode = ExplorerFormDisplayMode.Unknown
            If adxExplorerCommandBarComboBox.Text = "Inbox only" Then
                newExplorerMode = ExplorerFormDisplayMode.InboxOnlyItem
            End If
            If adxExplorerCommandBarComboBox.Text = "Inbox and subfolders" Then
                newExplorerMode = ExplorerFormDisplayMode.InboxAndSubfoldersItem
            End If
            If newExplorerMode <> Me.explorerMode Then
                SetExplorerFormDisplayMode(newExplorerMode, currentFolder)
                AdxOlFormsCollectionItem1.ApplyTo(activeExplorer)
            End If
        Finally
            If activeExplorer IsNot Nothing Then Marshal.ReleaseComObject(activeExplorer)
            If currentFolder IsNot Nothing Then Marshal.ReleaseComObject(currentFolder)
        End Try
    End Sub

#Region "Outlook Object Model routines"

    Private Function InboxFullFolderName() As String
        If ((_rootFolder IsNot Nothing) AndAlso (_inboxFolder IsNot Nothing)) Then
            Return String.Concat(_rootFolder.Name, "\", _inboxFolder.Name)
        Else
            Return String.Empty
        End If
    End Function

    Private Function IsInboxFolder(ByVal folder As Outlook.MAPIFolder) As Boolean
        Return ((folder IsNot Nothing) AndAlso (folder.EntryID = Me._inboxFolder.EntryID))
    End Function

    Friend Function GetDefaultFolder(ByVal OutlookAppObj As Outlook._Application, ByVal DefaultFolder As Outlook.OlDefaultFolders) As Outlook.MAPIFolder
        Dim result As Outlook.MAPIFolder = Nothing
        Try
            Dim OutlookNameSpaceObj As Outlook.NameSpace = OutlookAppObj.GetNamespace("MAPI")
            If OutlookNameSpaceObj IsNot Nothing Then
                Try
                    result = OutlookNameSpaceObj.GetDefaultFolder(DefaultFolder)
                Finally
                    Marshal.ReleaseComObject(OutlookNameSpaceObj)
                End Try
            End If
            Return result
        Catch
            Return Nothing
        End Try
    End Function

    Friend Function GetRootFolder(ByVal InboxFolder As Outlook.MAPIFolder) As Outlook.MAPIFolder
        If InboxFolder IsNot Nothing Then
            Try
                Dim parent As Object = InboxFolder.Parent
                Dim rootFolder As Outlook.MAPIFolder = TryCast(parent, Outlook.MAPIFolder)
                Try
                    Return rootFolder
                Finally
                    If (parent IsNot Nothing) AndAlso (rootFolder Is Nothing) Then
                        Marshal.ReleaseComObject(parent)
                        parent = Nothing
                    End If
                End Try
            Catch
                Return Nothing
            End Try
        Else
            Return Nothing
        End If
    End Function

    Friend Function IsUnderFolder(ByVal RootFolderObj As Outlook.MAPIFolder, ByVal FolderObj As Outlook.MAPIFolder) As Boolean
        If (RootFolderObj Is Nothing) OrElse (FolderObj Is Nothing) Then
            Return False
        Else
            Dim FolderEntryID As String = [String].Empty
            Dim RootFolderEntryID As String = [String].Empty
            Try
                FolderEntryID = FolderObj.EntryID
                RootFolderEntryID = RootFolderObj.EntryID
            Catch
                Return False
            End Try

            If (FolderEntryID <> [String].Empty) AndAlso _
            (CultureInfo.InvariantCulture.CompareInfo.IndexOf(FolderEntryID, RootFolderEntryID, CompareOptions.IgnoreCase) = 0) Then
                Return True
            Else
                Dim parent As Object = Nothing

                Try
                    parent = FolderObj.Parent
                Catch
                    Return False
                End Try

                Try
                    Dim ParentFolderObj As Outlook.MAPIFolder = TryCast(parent, Outlook.MAPIFolder)
                    Return IsUnderFolder(RootFolderObj, ParentFolderObj)
                Finally
                    If parent IsNot Nothing Then
                        Marshal.ReleaseComObject(parent)
                        parent = Nothing
                    End If
                End Try
            End If
        End If
    End Function

#End Region

    Private Sub adxRibbonButton1_OnClick(sender As System.Object, control As AddinExpress.MSO.IRibbonControl, pressed As System.Boolean) Handles adxRibbonButton1.OnClick
        ProcessInspectorButtonClick()
    End Sub

    Private Sub adxRibbonButton2_OnClick(sender As System.Object, control As AddinExpress.MSO.IRibbonControl, pressed As System.Boolean) Handles adxRibbonButton2.OnClick
        ProcessInspectorButtonClick()
    End Sub

    Private Sub AdxOlFormsManager1_OnInitialize() Handles AdxOlFormsManager1.OnInitialize
        _inboxFolder = GetDefaultFolder(OutlookApp, Outlook.OlDefaultFolders.olFolderInbox)
        _rootFolder = GetRootFolder(_inboxFolder)
        SetExplorerFormDisplayMode(ExplorerFormDisplayMode.InboxOnlyItem, Nothing)
    End Sub

    Private Sub AdxRibbonComboBox1_OnChange(sender As System.Object, Control As AddinExpress.MSO.IRibbonControl, text As System.String) Handles AdxRibbonComboBox1.OnChange
        Dim activeExplorer As Outlook.Explorer = Nothing
        Dim currentFolder As Outlook.MAPIFolder = Nothing
        Try
            activeExplorer = OutlookApp.ActiveExplorer()
            If activeExplorer IsNot Nothing Then
                currentFolder = activeExplorer.CurrentFolder
            End If
            Dim newExplorerMode As ExplorerFormDisplayMode = ExplorerFormDisplayMode.Unknown
            If text = "Inbox only" Then
                newExplorerMode = ExplorerFormDisplayMode.InboxOnlyItem
            End If
            If text = "Inbox and subfolders" Then
                newExplorerMode = ExplorerFormDisplayMode.InboxAndSubfoldersItem
            End If
            If newExplorerMode <> Me.explorerMode Then
                SetExplorerFormDisplayMode(newExplorerMode, currentFolder)
                AdxOlFormsCollectionItem1.ApplyTo(activeExplorer)
            End If
        Finally
            If activeExplorer IsNot Nothing Then Marshal.ReleaseComObject(activeExplorer)
            If currentFolder IsNot Nothing Then Marshal.ReleaseComObject(currentFolder)
        End Try
    End Sub

    Private Sub RestoreCommandBarButton_Click(sender As System.Object) Handles RestoreCommandBarButton.Click
        If HiddenExplorerForm IsNot Nothing Then
            TryCast(HiddenExplorerForm, ADXOlForm1).ShowAndClearHideIndication()
            HiddenExplorerForm = Nothing
        End If
    End Sub

    Private Sub AdxRibbonButton3_OnClick(sender As System.Object, control As AddinExpress.MSO.IRibbonControl, pressed As System.Boolean) Handles AdxRibbonButton3.OnClick
        If HiddenExplorerForm IsNot Nothing Then
            TryCast(HiddenExplorerForm, ADXOlForm1).ShowAndClearHideIndication()
            HiddenExplorerForm = Nothing
        End If
    End Sub
End Class

